- NAME
- DESCRIPTION

- Identity
- Supported parameters

- SEE ALSO
- COPYRIGHT

# NAME

EVP_MAC-KMAC, EVP_MAC-KMAC128, EVP_MAC-KMAC256 - The KMAC EVP_MAC implementations

# DESCRIPTION

Support for computing KMAC MACs through the EVP_MAC API.

## Identity

These implementations are identified with one of these names and properties, to be used with EVP_MAC_fetch():

"KMAC-128", "provider=default" or "provider=fips"
"KMAC-256", "provider=default" or "provider=fips"

## Supported parameters

The general description of these parameters can be found in EVP_MAC(3)/PARAMETERS.

All these parameters can be set with `EVP_MAC_CTX_set_params()`. Furthermore, the "size" parameter can be retrieved with `EVP_MAC_CTX_get_params()`, or with `EVP_MAC_size()`. The length of the "size" parameter should not exceed that of a size_t.

"key" (OSSL_MAC_PARAM_KEY) <octet string>
"custom" (OSSL_MAC_PARAM_CUSTOM) <octet string>
"size" (OSSL_MAC_PARAM_SIZE) <unsigned integer>
"xof" (OSSL_MAC_PARAM_XOF) <integer>

The "xof" parameter value is expected to be 1 or 0. Use 1 to enable XOF mode. If XOF is enabled then the output length that is encoded as part of the input stream is set to zero.

# SEE ALSO

EVP_MAC_CTX_get_params(3), EVP_MAC_CTX_set_params(3), EVP_MAC(3)/PARAMETERS, OSSL_PARAM(3)

# COPYRIGHT

Copyright 2018-2019 The OpenSSL Project Authors. All Rights Reserved.

Licensed under the Apache License 2.0 (the "License"). You may not use this file except in compliance with the License. You can obtain a copy in the file LICENSE in the source distribution or at https://www.openssl.org/source/license.html.